import { Y as t, X as S, w as u, cF as v, a3 as h, Z as y, ep as V, az as P, O as r, c1 as m, cJ as p, U as E, F as o, a8 as l, G as f, a9 as i, aa as n, ah as g, ab as R, ac as T, ae as s, ad as x, eq as k, er as D } from "./3f20ad53.js";
import { useContext as b, useRef as $, useState as M } from "react";
import { mediaCommonChildren as j, mediaMethods as F } from "./e773b698.js";
import "react-dom";
const U = [{
  label: t("video.play"),
  value: "play",
  description: t("video.playDesc")
}, {
  label: t("video.pause"),
  value: "pause",
  description: t("video.pauseDesc")
}, {
  label: t("video.load"),
  value: "load",
  description: t("video.loadDesc")
}, {
  label: t("video.ended"),
  value: "ended",
  description: t("video.endedDesc")
}], B = S.div`
${(e) => e.$style};
rotate:${(e) => e.$style.rotation};
${(e) => e.$animationStyle};
  height: 100%;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: center;

  div > video {
    object-fit: contain;
    pointer-events: auto;
    height: 100%;
    width: 100%;
    :focus-visible {
      outline: 0px;
    }
  }
`, H = (e) => {
  const a = $(null);
  let [C, w] = M(!1);
  return /* @__PURE__ */ o(B, {
    ref: e.containerRef,
    $style: e.style,
    $animationStyle: e.animationStyle,
    children: /* @__PURE__ */ o(k, {
      config: {
        file: {
          forceVideo: !0
        }
      },
      light: e.autoPlay ? "" : e.poster.value,
      ref: (c) => {
        e.viewRef(c), a.current = c;
      },
      url: e.src.value,
      onPlay: () => e.onEvent("play"),
      onReady: () => {
        a.current != null && e.duration.onChange(a.current.getDuration()), e.onEvent("load");
      },
      onPause: () => e.onEvent("pause"),
      onEnded: () => e.onEvent("ended"),
      loop: e.loop,
      controls: !e.controls,
      volume: e.volume,
      style: e.style,
      playbackRate: e.playbackRate,
      onClickPreview: () => {
        w(!0);
      },
      draggable: !1,
      playIcon: D(),
      playing: e.autoPlay || C,
      onProgress: () => {
        a.current != null && e.currentTimeStamp.onChange(a.current.getCurrentTime());
      }
    })
  });
}, I = {
  src: u(v, t("video.defaultSrcUrl")),
  poster: u(v, t("video.defaultPosterUrl")),
  onEvent: h(U),
  style: y(V),
  animationStyle: y(P),
  autoPlay: r,
  loop: r,
  controls: r,
  volume: m.closed(0, 1, 1),
  playbackRate: m.closed(1, 2, 1),
  currentTimeStamp: p("currentTimeStamp", 0),
  duration: p("duration"),
  ...j
};
let d = function() {
  return new E(I, (e) => /* @__PURE__ */ o(H, {
    ...e
  })).setPropertyViewFn((e) => /* @__PURE__ */ l(f, {
    children: [/* @__PURE__ */ o(i, {
      name: n.basic,
      children: e.src.propertyView({
        label: t("video.src"),
        tooltip: t("video.srcDesc")
      })
    }), (b(g).editorModeStatus === "logic" || b(g).editorModeStatus === "both") && /* @__PURE__ */ l(f, {
      children: [/* @__PURE__ */ l(i, {
        name: n.interaction,
        children: [e.onEvent.getPropertyView(), R(e)]
      }), /* @__PURE__ */ l(i, {
        name: n.advanced,
        children: [e.poster.propertyView({
          label: t("video.poster"),
          tooltip: t("video.posterTooltip")
        }), e.volume.propertyView({
          label: t("video.volume"),
          tooltip: t("video.volumeTooltip")
        }), e.playbackRate.propertyView({
          label: t("video.playbackRate"),
          tooltip: t("video.playbackRateTooltip")
        }), e.autoPlay.propertyView({
          label: t("video.autoPlay"),
          tooltip: t("video.autoPlayTooltip")
        }), e.loop.propertyView({
          label: t("video.loop")
        }), e.controls.propertyView({
          label: t("video.controls"),
          tooltip: t("video.controlsTooltip")
        })]
      }), /* @__PURE__ */ o(i, {
        name: n.style,
        children: e.style.getPropertyView()
      }), /* @__PURE__ */ o(i, {
        name: n.animationStyle,
        hasTooltip: !0,
        children: e.animationStyle.getPropertyView()
      })]
    })]
  })).setExposeMethodConfigs(F()).build();
}();
d = class extends d {
  autoHeight() {
    return !1;
  }
};
const A = T(d, [new s("src", t("video.srcDesc")), new s("currentTimeStamp", t("video.currentTimeStamp")), new s("duration", t("video.duration")), x]);
export {
  A as VideoComp
};
