import { X as $, ah as p, dh as C, F as n, a8 as v, di as b, dk as m, dj as H, dr as W, av as R, dq as k } from "./3f20ad53.js";
import { useContext as z } from "react";
import "react-dom";
const O = (o) => R`
    border-color: ${o.border};
    border-width: ${o.borderWidth};
    border-radius: ${o.radius};
    border-style: ${o.borderStyle};
    overflow: hidden;
    padding: ${o.padding};
    ${o.background && `background-color: ${o.background};`}
    ${o.backgroundImage && `background-image: url(${o.backgroundImage});`}
    ${o.backgroundImageRepeat && `background-repeat: ${o.backgroundImageRepeat};`}
    ${o.backgroundImageSize && `background-size: ${o.backgroundImageSize};`}
    ${o.backgroundImagePosition && `background-position: ${o.backgroundImagePosition};`}
    ${o.backgroundImageOrigin && `background-origin: ${o.backgroundImageOrigin};`}
  `, F = $.div`
  display: flex;
  flex-flow: column;
  height: 100%;
  border: 1px solid #d7d9e0;
  border-radius: 4px;
  ${(o) => o.$style && O(o.$style)}
  ${(o) => o.$animationStyle && o.$animationStyle}
`, G = $(k)`
  overflow: visible;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
`, S = $(k)`
  border-top: ${(o) => `${o.$showBorder ? o.$borderWidth : 0} solid ${o.$borderColor}`};
  flex: 1;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
`, j = $(k)`
  border-top: ${(o) => `${o.$showBorder ? o.$borderWidth : 0} solid ${o.$borderColor}`};
  overflow: visible;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
  ${(o) => o.$footerBackgroundImage && `background-image: url(${o.$footerBackgroundImage});`}
  ${(o) => o.$footerBackgroundImageRepeat && `background-repeat: ${o.$footerBackgroundImageRepeat};`}
  ${(o) => o.$footerBackgroundImageSize && `background-size: ${o.$footerBackgroundImageSize};`}
  ${(o) => o.$footerBackgroundImagePosition && `background-position: ${o.$footerBackgroundImagePosition};`}
  ${(o) => o.$footerBackgroundImageOrigin && `background-origin: ${o.$footerBackgroundImageOrigin};`}
`;
function E(o) {
  const {
    container: a,
    animationStyle: s
  } = o, {
    showHeader: d,
    showFooter: u
  } = a, i = a.showBody || !d && !u, h = a.scrollbars, {
    items: l,
    ...I
  } = a.header, {
    items: B,
    ...f
  } = a.body[0].children.view.getView(), {
    items: P,
    ...w
  } = a.footer, {
    style: e,
    headerStyle: g,
    bodyStyle: t,
    footerStyle: r
  } = a, x = z(p).getAppSettings().maxWidth, c = C(x) ? 8 : 0;
  return /* @__PURE__ */ n("div", {
    style: {
      padding: e.margin,
      height: "100%"
    },
    children: /* @__PURE__ */ v(F, {
      $style: e,
      $animationStyle: s,
      children: [d && /* @__PURE__ */ n(b.Provider, {
        value: g.headerBackground,
        children: /* @__PURE__ */ n(G, {
          ...I,
          items: m(l),
          autoHeight: !0,
          emptyRows: 5,
          minHeight: "46px",
          containerPadding: [c, 3],
          showName: {
            bottom: i || u ? 20 : 0
          },
          $backgroundColor: (g == null ? void 0 : g.headerBackground) || "transparent",
          style: {
            padding: g.containerHeaderPadding
          }
        })
      }), i && /* @__PURE__ */ n(b.Provider, {
        value: t.background,
        children: /* @__PURE__ */ n(H, {
          style: {
            height: a.autoHeight ? "auto" : "100%",
            margin: "0px",
            padding: "0px"
          },
          hideScrollbar: !h,
          children: /* @__PURE__ */ n(S, {
            $showBorder: d,
            ...f,
            items: m(B),
            autoHeight: a.autoHeight,
            emptyRows: 14,
            minHeight: d ? "143px" : "142px",
            containerPadding: d && u || d ? [c, 11.5] : [c, 11],
            hintPlaceholder: o.hintPlaceholder ?? W,
            $backgroundColor: (t == null ? void 0 : t.background) || "transparent",
            $borderColor: e == null ? void 0 : e.border,
            $borderWidth: e == null ? void 0 : e.borderWidth,
            style: {
              padding: t.containerBodyPadding
            }
          })
        })
      }), u && /* @__PURE__ */ n(b.Provider, {
        value: r.footerBackground,
        children: /* @__PURE__ */ n(j, {
          $showBorder: d || i,
          ...w,
          items: m(P),
          autoHeight: !0,
          emptyRows: 5,
          minHeight: i ? "47px" : "46px",
          containerPadding: i || d ? [c, 3.5] : [c, 3],
          showName: {
            top: d || i ? 20 : 0
          },
          $backgroundColor: (r == null ? void 0 : r.footerBackground) || "transparent",
          $footerBackgroundImage: r == null ? void 0 : r.footerBackgroundImage,
          $footerBackgroundImageRepeat: r == null ? void 0 : r.footerBackgroundImageRepeat,
          $footerBackgroundImageSize: r == null ? void 0 : r.footerBackgroundImageSize,
          $footerBackgroundImagePosition: r == null ? void 0 : r.footerBackgroundImagePosition,
          $footerBackgroundImageOrigin: r == null ? void 0 : r.footerBackgroundImageOrigin,
          $borderColor: e == null ? void 0 : e.border,
          $borderWidth: e == null ? void 0 : e.borderWidth,
          style: {
            padding: r.containerFooterPadding
          }
        })
      })]
    })
  });
}
export {
  E as TriContainer
};
