import { X as p, ah as E, dh as q, F as d, eQ as J, hH as K, hI as M, a8 as I, hJ as w, G as x, di as m, dj as k, dk as c, hK as W, dr as z, av as Q, dq as v } from "./3f20ad53.js";
import { useContext as X, useRef as D, useEffect as Y } from "react";
import "react-dom";
const {
  Header: Z,
  Content: O,
  Footer: _,
  Sider: C
} = w, A = p.div`
  width: 100%;
  top: 0;
  max-width: inherit;
  overflow: auto;
  height: 100%;
`, S = (o) => Q`
    border-color: ${o.border};
    border-width: ${o.borderWidth};
    border-radius: ${o.radius};
    overflow: hidden;
    padding: ${o.padding};
    ${o.background && `background-color: ${o.background};`}
    ${o.backgroundImage && `background-image: url(${o.backgroundImage});`}
    ${o.backgroundImageRepeat && `background-repeat: ${o.backgroundImageRepeat};`}
    ${o.backgroundImageSize && `background-size: ${o.backgroundImageSize};`}
    ${o.backgroundImagePosition && `background-position: ${o.backgroundImagePosition};`}
    ${o.backgroundImageOrigin && `background-origin: ${o.backgroundImageOrigin};`}
  `, y = p.div`
  display: flex;
  flex-flow: column;
  height: 100%;
  border: 1px solid #d7d9e0;
  border-radius: 4px;
  ${(o) => o.$style && S(o.$style)}
  ${(o) => o.$animationStyle}
`, rr = p(v)`
  overflow: visible;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
`, P = p(v)`
  overflow: auto;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
  ${(o) => o.$siderBackgroundImage && `background-image: url(${o.$siderBackgroundImage});`}
  ${(o) => o.$siderBackgroundImageRepeat && `background-repeat: ${o.$siderBackgroundImageRepeat};`}
  ${(o) => o.$siderBackgroundImageSize && `background-size: ${o.$siderBackgroundImageSize};`}
  ${(o) => o.$siderBackgroundImagePosition && `background-position: ${o.$siderBackgroundImagePosition};`}
  ${(o) => o.$siderBackgroundImageOrigin && `background-origin: ${o.$siderBackgroundImageOrigin};`}
`, F = p(v)`
  border-top: ${(o) => `${o.$showBorder ? o.$borderWidth : 0} solid ${o.$borderColor}`};
  flex: 1;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
`, or = p(v)`
  border-top: ${(o) => `${o.$showBorder ? o.$borderWidth : 0} solid ${o.$borderColor}`};
  overflow: visible;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
  ${(o) => o.$footerBackgroundImage && `background-image: url(${o.$footerBackgroundImage});`}
  ${(o) => o.$footerBackgroundImageRepeat && `background-repeat: ${o.$footerBackgroundImageRepeat};`}
  ${(o) => o.$footerBackgroundImageSize && `background-size: ${o.$footerBackgroundImageSize};`}
  ${(o) => o.$footerBackgroundImagePosition && `background-position: ${o.$footerBackgroundImagePosition};`}
  ${(o) => o.$footerBackgroundImageOrigin && `background-origin: ${o.$footerBackgroundImageOrigin};`}
`;
function ir(o) {
  const {
    container: a,
    siderCollapsed: $,
    setSiderCollapsed: l,
    animationStyle: G
  } = o, {
    showHeader: t,
    showFooter: h,
    showSider: u
  } = a, {
    items: N,
    ...L
  } = a.header, {
    items: f,
    ...H
  } = a.body[0].children.view.getView(), {
    items: U,
    ...j
  } = a.footer, {
    items: b,
    ...B
  } = a.sider, {
    style: e,
    headerStyle: s,
    siderStyle: r,
    bodyStyle: i,
    footerStyle: n
  } = a, T = X(E).getAppSettings().maxWidth;
  q(T);
  const R = D();
  function V(g) {
    o.setSiderCollapsed(g);
  }
  return Y(() => {
    l(a.siderCollapsed);
  }, [a.siderCollapsed]), /* @__PURE__ */ d("div", {
    style: {
      padding: e.margin,
      height: "100%"
    },
    children: /* @__PURE__ */ d(J, {
      theme: {
        components: {
          Layout: {
            triggerBg: K(a.siderStyle.siderBackground),
            triggerColor: M(a.siderStyle.siderBackground, "black", "white"),
            siderBg: a.siderStyle.siderBackground
          }
        }
      },
      children: /* @__PURE__ */ I(y, {
        $style: e,
        $animationStyle: G,
        children: [/* @__PURE__ */ I(w, {
          style: {
            padding: "0px"
          },
          hasSider: u && !a.innerSider,
          children: [u && !a.innerSider && !a.siderRight && /* @__PURE__ */ d(x, {
            children: /* @__PURE__ */ d(m.Provider, {
              value: r == null ? void 0 : r.siderBackground,
              children: /* @__PURE__ */ d(C, {
                width: a.siderWidth,
                style: {
                  padding: "0px",
                  margin: "0px",
                  backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent"
                },
                collapsible: a.siderCollapsible,
                breakpoint: "sm",
                collapsedWidth: a.siderCollapsedWidth,
                collapsed: $,
                onCollapse: (g) => V(g),
                children: /* @__PURE__ */ d(k, {
                  style: {
                    height: a.autoHeight ? "auto" : "100%",
                    margin: "0px",
                    padding: "0px"
                  },
                  hideScrollbar: !a.siderScrollbars,
                  children: /* @__PURE__ */ d(P, {
                    ...B,
                    items: c(b),
                    autoHeight: !0,
                    emptyRows: 30,
                    minHeight: `calc(100vh - ${e.padding}px)`,
                    containerPadding: [0, 0],
                    showName: {
                      bottom: h ? 20 : 0
                    },
                    $backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent",
                    $siderBackgroundImage: r == null ? void 0 : r.siderBackgroundImage,
                    $siderBackgroundImageRepeat: r == null ? void 0 : r.siderBackgroundImageRepeat,
                    $siderBackgroundImageSize: r == null ? void 0 : r.siderBackgroundImageSize,
                    $siderBackgroundImagePosition: r == null ? void 0 : r.siderBackgroundImagePosition,
                    $siderBackgroundImageOrigin: r == null ? void 0 : r.siderBackgroundImageOrigin,
                    style: {
                      padding: r.containerSiderPadding
                    }
                  })
                })
              })
            })
          }), /* @__PURE__ */ I(w, {
            style: {
              padding: "0px"
            },
            children: [t && /* @__PURE__ */ d(x, {
              children: /* @__PURE__ */ d(m.Provider, {
                value: e.background,
                children: /* @__PURE__ */ d(Z, {
                  style: {
                    backgroundColor: (s == null ? void 0 : s.headerBackground) || "transparent",
                    padding: "0px",
                    margin: "0px"
                  },
                  children: /* @__PURE__ */ d(rr, {
                    ...L,
                    items: c(N),
                    autoHeight: !0,
                    emptyRows: 5,
                    minHeight: "46px",
                    containerPadding: [0, 0],
                    showName: {
                      bottom: h ? 20 : 0
                    },
                    $backgroundColor: (s == null ? void 0 : s.headerBackground) || "transparent",
                    style: {
                      padding: s.containerHeaderPadding
                    }
                  })
                })
              })
            }), u && a.innerSider ? /* @__PURE__ */ d(x, {
              children: /* @__PURE__ */ I(w, {
                style: {
                  padding: "0px"
                },
                hasSider: u && a.innerSider,
                children: [u && !a.siderRight && /* @__PURE__ */ d(m.Provider, {
                  value: r == null ? void 0 : r.siderBackground,
                  children: /* @__PURE__ */ d(C, {
                    width: a.siderWidth,
                    style: {
                      padding: "0px",
                      margin: "0px",
                      marginTop: e.borderWidth,
                      backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent"
                    },
                    collapsible: a.siderCollapsible,
                    breakpoint: "sm",
                    collapsedWidth: a.siderCollapsedWidth,
                    collapsed: $,
                    onCollapse: (g) => l(g),
                    children: /* @__PURE__ */ d(k, {
                      style: {
                        height: a.autoHeight ? "auto" : "100%",
                        margin: "0px",
                        padding: "0px"
                      },
                      hideScrollbar: !a.siderScrollbars,
                      children: /* @__PURE__ */ d(P, {
                        ...B,
                        items: c(b),
                        autoHeight: !0,
                        emptyRows: 30,
                        minHeight: `calc(100vh - ${e.padding}px)`,
                        containerPadding: [0, 0],
                        showName: {
                          bottom: h ? 20 : 0
                        },
                        $backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent",
                        $siderBackgroundImage: r == null ? void 0 : r.siderBackgroundImage,
                        $siderBackgroundImageRepeat: r == null ? void 0 : r.siderBackgroundImageRepeat,
                        $siderBackgroundImageSize: r == null ? void 0 : r.siderBackgroundImageSize,
                        $siderBackgroundImagePosition: r == null ? void 0 : r.siderBackgroundImagePosition,
                        $siderBackgroundImageOrigin: r == null ? void 0 : r.siderBackgroundImageOrigin,
                        style: {
                          padding: r.containerSiderPadding
                        }
                      })
                    })
                  })
                }), /* @__PURE__ */ d(O, {
                  style: {
                    padding: "0px",
                    margin: "0px",
                    backgroundColor: (i == null ? void 0 : i.background) || "transparent"
                  },
                  children: /* @__PURE__ */ d(k, {
                    style: {
                      height: a.autoHeight ? "auto" : "100%",
                      margin: "0px",
                      padding: "0px"
                    },
                    hideScrollbar: !a.contentScrollbars,
                    children: a.showApp && a.contentApp != "" ? /* @__PURE__ */ d(m.Provider, {
                      value: i == null ? void 0 : i.background,
                      children: /* @__PURE__ */ d(A, {
                        children: /* @__PURE__ */ d(W, {
                          ref: R,
                          appId: a.contentApp,
                          baseUrl: a.baseUrl
                        })
                      })
                    }) : /* @__PURE__ */ d(F, {
                      $showBorder: t,
                      ...H,
                      items: c(f),
                      autoHeight: a.autoHeight,
                      emptyRows: 14,
                      minHeight: t ? "143px" : "142px",
                      containerPadding: [0, 0],
                      hintPlaceholder: o.hintPlaceholder ?? z,
                      $backgroundColor: (i == null ? void 0 : i.background) || "transparent",
                      $borderColor: e == null ? void 0 : e.border,
                      $borderWidth: e == null ? void 0 : e.borderWidth,
                      style: {
                        padding: i.containerBodyPadding
                      }
                    })
                  })
                }), u && a.siderRight && /* @__PURE__ */ d(m.Provider, {
                  value: r == null ? void 0 : r.siderBackground,
                  children: /* @__PURE__ */ d(C, {
                    width: a.siderWidth,
                    style: {
                      padding: "0px",
                      margin: "0px",
                      backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent"
                    },
                    collapsible: a.siderCollapsible,
                    breakpoint: "sm",
                    collapsedWidth: a.siderCollapsedWidth,
                    reverseArrow: !0,
                    collapsed: $,
                    onCollapse: (g) => l(g),
                    children: /* @__PURE__ */ d(k, {
                      style: {
                        height: a.autoHeight ? "auto" : "100%",
                        margin: "0px",
                        padding: "0px"
                      },
                      hideScrollbar: !a.siderScrollbars,
                      children: /* @__PURE__ */ d(P, {
                        ...B,
                        items: c(b),
                        autoHeight: !0,
                        emptyRows: 30,
                        minHeight: `calc(100vh - ${e.padding}px)`,
                        containerPadding: [0, 0],
                        showName: {
                          bottom: h ? 20 : 0
                        },
                        $backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent",
                        $siderBackgroundImage: r == null ? void 0 : r.siderBackgroundImage,
                        $siderBackgroundImageRepeat: r == null ? void 0 : r.siderBackgroundImageRepeat,
                        $siderBackgroundImageSize: r == null ? void 0 : r.siderBackgroundImageSize,
                        $siderBackgroundImagePosition: r == null ? void 0 : r.siderBackgroundImagePosition,
                        $siderBackgroundImageOrigin: r == null ? void 0 : r.siderBackgroundImageOrigin,
                        style: {
                          padding: r.containerSiderPadding
                        }
                      })
                    })
                  })
                })]
              })
            }) : /* @__PURE__ */ d(O, {
              style: {
                padding: "0px",
                margin: "0px"
              },
              children: /* @__PURE__ */ d(k, {
                style: {
                  height: a.autoHeight ? "auto" : "100%",
                  margin: "0px",
                  padding: "0px"
                },
                hideScrollbar: !a.contentScrollbars,
                children: a.showApp && a.contentApp != "" ? /* @__PURE__ */ d(m.Provider, {
                  value: i == null ? void 0 : i.background,
                  children: /* @__PURE__ */ d(A, {
                    children: /* @__PURE__ */ d(W, {
                      ref: R,
                      appId: a.contentApp,
                      baseUrl: a.baseUrl
                    })
                  })
                }) : /* @__PURE__ */ d(F, {
                  $showBorder: t,
                  ...H,
                  items: c(f),
                  autoHeight: a.autoHeight,
                  emptyRows: 14,
                  minHeight: t ? "143px" : "142px",
                  containerPadding: [0, 0],
                  hintPlaceholder: o.hintPlaceholder ?? z,
                  $backgroundColor: (i == null ? void 0 : i.background) || "transparent",
                  $borderColor: e == null ? void 0 : e.border,
                  $borderWidth: e == null ? void 0 : e.borderWidth,
                  style: {
                    padding: i.containerBodyPadding
                  }
                })
              })
            }), h && /* @__PURE__ */ d(_, {
              style: {
                textAlign: "center",
                padding: "0px",
                margin: "0px",
                backgroundColor: (n == null ? void 0 : n.footerBackground) || "transparent"
              },
              children: /* @__PURE__ */ d(or, {
                $showBorder: t,
                ...j,
                items: c(U),
                autoHeight: !0,
                emptyRows: 5,
                minHeight: "48px",
                containerPadding: [0, 0],
                showName: {
                  top: t ? 20 : 0
                },
                $backgroundColor: (n == null ? void 0 : n.footerBackground) || "transparent",
                $footerBackgroundImage: n == null ? void 0 : n.footerBackgroundImage,
                $footerBackgroundImageRepeat: n == null ? void 0 : n.footerBackgroundImageRepeat,
                $footerBackgroundImageSize: n == null ? void 0 : n.footerBackgroundImageSize,
                $footerBackgroundImagePosition: n == null ? void 0 : n.footerBackgroundImagePosition,
                $footerBackgroundImageOrigin: n == null ? void 0 : n.footerBackgroundImageOrigin,
                $borderColor: e == null ? void 0 : e.border,
                $borderWidth: e == null ? void 0 : e.borderWidth,
                style: {
                  padding: n.containerFooterPadding
                }
              })
            })]
          }), u && !a.innerSider && a.siderRight && /* @__PURE__ */ d(x, {
            children: /* @__PURE__ */ d(m.Provider, {
              value: r == null ? void 0 : r.siderBackground,
              children: /* @__PURE__ */ d(C, {
                width: a.siderWidth,
                style: {
                  padding: "0px",
                  margin: "0px",
                  backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent"
                },
                collapsible: a.siderCollapsible,
                breakpoint: "sm",
                collapsedWidth: a.siderCollapsedWidth,
                reverseArrow: !0,
                collapsed: $,
                onCollapse: (g) => l(g),
                children: /* @__PURE__ */ d(k, {
                  style: {
                    height: a.autoHeight ? "auto" : "100%",
                    margin: "0px",
                    padding: "0px"
                  },
                  hideScrollbar: !a.siderScrollbars,
                  children: /* @__PURE__ */ d(P, {
                    ...B,
                    items: c(b),
                    autoHeight: !0,
                    emptyRows: 30,
                    minHeight: `calc(100vh - ${e.padding}px)`,
                    containerPadding: [0, 0],
                    showName: {
                      bottom: h ? 20 : 0
                    },
                    $backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent",
                    $siderBackgroundImage: r == null ? void 0 : r.siderBackgroundImage,
                    $siderBackgroundImageRepeat: r == null ? void 0 : r.siderBackgroundImageRepeat,
                    $siderBackgroundImageSize: r == null ? void 0 : r.siderBackgroundImageSize,
                    $siderBackgroundImagePosition: r == null ? void 0 : r.siderBackgroundImagePosition,
                    $siderBackgroundImageOrigin: r == null ? void 0 : r.siderBackgroundImageOrigin,
                    style: {
                      padding: r.containerSiderPadding
                    }
                  })
                })
              })
            })
          })]
        }), /* @__PURE__ */ d("style", {
          children: `
              .ant-layout-sider-trigger {
                bottom: 4px !important;
                ${a.siderRight ? `
                  right: 8px !important;
                ` : `
                  left: 8px !important;}
                `}
                
              }
            `
        })]
      })
    })
  });
}
export {
  ir as PageLayout
};
