import { X as d, S as O, w, a3 as P, du as N, bS as F, Z as C, dZ as L, az as R, Y as s, U as A, F as e, G as $, a8 as r, aj as I, a9 as a, aa as l, d_ as T, ah as o, ab as k, ac as B, ae as M, ad as D, al as H, ag as G } from "./3f20ad53.js";
import { useContext as n } from "react";
import { navListComp as K } from "./091d8642.js";
import { a as Z } from "./fcb12610.js";
import "react-dom";
const J = d("div")`
${(t) => t.$animationStyle}
  height: 100%;
  border-radius: ${(t) => t.$borderRadius ? t.$borderRadius : "2px"};
  box-sizing: border-box;
  border: ${(t) => t.$borderWidth ? `${t.$borderWidth}` : "1px"} ${(t) => t.$borderStyle} ${(t) => t.$borderColor};
  background-color: ${(t) => t.$bgColor};
`, X = d("div")`
  // margin: 0 -16px;
  height: 100%;
  display: flex;
  justify-content: ${(t) => t.$justify ? "space-between" : "left"};
`, Y = d.div`
  height: 30px;
  line-height: 30px;
  padding: ${(t) => t.$padding ? t.$padding : "0 16px"};
  color: ${(t) => t.$active ? t.$activeColor : t.$color};
  font-weight: ${(t) => t.$textWeight ? t.$textWeight : 500};
  font-family:${(t) => t.$fontFamily ? t.$fontFamily : "sans-serif"};
  font-style:${(t) => t.$fontStyle ? t.$fontStyle : "normal"};
  font-size:${(t) => t.$textSize ? t.$textSize : "14px"};
  text-transform:${(t) => t.$textTransform ? t.$textTransform : ""};
  text-decoration:${(t) => t.$textDecoration ? t.$textDecoration : ""};
  margin:${(t) => t.$margin ? t.$margin : "0px"};
  
  &:hover {
    color: ${(t) => t.$activeColor};
    cursor: pointer;
  }

  .anticon {
    margin-left: 5px;
  }
`, _ = d.div`
  cursor: pointer;
  height: 30px;
  line-height: 0;
  margin-left: 16px;

  img {
    height: 100%;
  }
`, q = d.div`
  flex: 1;
  display: flex;
  flex-direction: row;
  justify-content: ${(t) => t.$align};
`, Q = d(H)`
  &.ant-dropdown-menu {
    min-width: 160px;
  }
`, p = [G];
function tt(t) {
  return t && (t.hasOwnProperty("accentColor") || t.hasOwnProperty("backgroundColor") || t.hasOwnProperty("borderColor") || t.hasOwnProperty("color")) ? {
    text: t.color,
    accent: t.accentColor,
    background: t.backgroundColor,
    border: t.borderColor
  } : t;
}
const et = {
  logoUrl: O,
  logoEvent: w(P(p), [{
    name: "click"
  }]),
  horizontalAlignment: N(),
  style: F(C(L), tt),
  animationStyle: C(R),
  items: w(K(), [{
    label: s("menuItem") + " 1"
  }])
}, ot = new A(et, (t) => {
  const V = t.items, u = /* @__PURE__ */ e($, {
    children: V.map((z, b) => {
      const {
        hidden: E,
        label: U,
        items: g,
        active: W,
        onEvent: j
      } = z.getView();
      if (E)
        return null;
      const f = g.filter((i) => !i.children.hidden.getView()), x = [], m = [];
      f.forEach((i, y) => {
        const c = y + "";
        i.children.active.getView() && m.push(c), x.push({
          key: c,
          label: i.children.label.getView()
        });
      });
      const S = /* @__PURE__ */ r(Y, {
        $active: W || m.length > 0,
        $color: t.style.text,
        $activeColor: t.style.accent,
        $fontFamily: t.style.fontFamily,
        $fontStyle: t.style.fontStyle,
        $textWeight: t.style.textWeight,
        $textSize: t.style.textSize,
        $padding: t.style.padding,
        $textTransform: t.style.textTransform,
        $textDecoration: t.style.textDecoration,
        $margin: t.style.margin,
        onClick: () => j("click"),
        children: [U, g.length > 0 && /* @__PURE__ */ e(Z, {})]
      }, b);
      if (f.length > 0) {
        const i = /* @__PURE__ */ e(Q, {
          onClick: (y) => {
            var v;
            const {
              onEvent: c
            } = (v = g[Number(y.key)]) == null ? void 0 : v.getView();
            c("click");
          },
          selectedKeys: m,
          items: x
        });
        return /* @__PURE__ */ e(I, {
          dropdownRender: () => i,
          children: S
        }, b);
      }
      return S;
    })
  }), h = t.horizontalAlignment === "justify";
  return /* @__PURE__ */ e(J, {
    $borderStyle: t.style.borderStyle,
    $animationStyle: t.animationStyle,
    $borderColor: t.style.border,
    $bgColor: t.style.background,
    $borderWidth: t.style.borderWidth,
    $borderRadius: t.style.radius,
    children: /* @__PURE__ */ r(X, {
      $justify: h,
      children: [t.logoUrl && /* @__PURE__ */ e(_, {
        onClick: () => t.logoEvent("click"),
        children: /* @__PURE__ */ e("img", {
          src: t.logoUrl,
          alt: "LOGO"
        })
      }), h ? u : /* @__PURE__ */ e(q, {
        $align: t.horizontalAlignment,
        children: u
      })]
    })
  });
}).setPropertyViewFn((t) => /* @__PURE__ */ r($, {
  children: [/* @__PURE__ */ e(a, {
    name: l.basic,
    children: T(t.items)
  }), (n(o).editorModeStatus === "logic" || n(o).editorModeStatus === "both") && /* @__PURE__ */ e(a, {
    name: l.interaction,
    children: k(t)
  }), (n(o).editorModeStatus === "layout" || n(o).editorModeStatus === "both") && /* @__PURE__ */ r(a, {
    name: l.layout,
    children: [t.horizontalAlignment.propertyView({
      label: s("navigation.horizontalAlignment"),
      radioButton: !0
    }), k(t)]
  }), (n(o).editorModeStatus === "logic" || n(o).editorModeStatus === "both") && /* @__PURE__ */ r(a, {
    name: l.advanced,
    children: [t.logoUrl.propertyView({
      label: s("navigation.logoURL"),
      tooltip: s("navigation.logoURLDesc")
    }), t.logoUrl.getView() && t.logoEvent.propertyView({
      inline: !0
    })]
  }), (n(o).editorModeStatus === "layout" || n(o).editorModeStatus === "both") && /* @__PURE__ */ r($, {
    children: [/* @__PURE__ */ e(a, {
      name: l.style,
      children: t.style.getPropertyView()
    }), /* @__PURE__ */ e(a, {
      name: l.animationStyle,
      hasTooltip: !0,
      children: t.animationStyle.getPropertyView()
    })]
  })]
})).build(), st = B(ot, [new M("logoUrl", s("navigation.logoURLDesc")), D, new M("items", s("navigation.itemsDesc"))]);
export {
  st as NavComp
};
